package geniusweb.voting.votingevaluators;

import static org.junit.Assert.assertEquals;
import static org.mockito.Mockito.mock;

import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.junit.Test;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;

import geniusweb.actions.PartyId;
import geniusweb.actions.Votes;
import geniusweb.voting.CollectedVotes;
import geniusweb.voting.VotingEvaluator;
import tudelft.utilities.junit.GeneralTests;

public class LargestAgreementTest extends GeneralTests<LargestAgreement> {
	private final ObjectMapper jackson = new ObjectMapper();

	private LargestAgreement lal1 = new LargestAgreement();
	private LargestAgreement lal1a = new LargestAgreement();
	private PartyId party1 = new PartyId("party1");
	private Votes votes1 = mock(Votes.class);
	private LargestAgreement lal2 = new LargestAgreement(
			new CollectedVotes(Collections.singletonMap(party1, votes1),
					Collections.singletonMap(party1, 1)));

	private String lalstring = "{\"LargestAgreement\":{}}";

	@Override
	public List<List<LargestAgreement>> getGeneralTestData() {
		return Arrays.asList(Arrays.asList(lal1, lal1a), Arrays.asList(lal2));
	}

	@Override
	public List<String> getGeneralTestStrings() {
		return Arrays.asList("LargestAgreement", "LargestAgreement");
	}

	@Test
	public void serializeTest() throws JsonProcessingException {
		// we use lal2 to also check we don't serialize the contents
		System.out.println(jackson.writeValueAsString(lal2));
		assertEquals(lalstring, jackson.writeValueAsString(lal2));
	}

	@Test
	public void deserializeTest() throws IOException {
		VotingEvaluator eval = jackson.readValue(lalstring,
				VotingEvaluator.class);
		// it should deserialize as the empty lal1 because we ignore the fields.
		assertEquals(lal1, eval);
	}

}
